//
//  ViewController.swift
//  TestApp
//
//  Created by Anton D. on 6/25/15.
//  Copyright © 2021 MindFusion. All rights reserved.
//

import UIKit
import Diagramming

class ViewController: UIViewController {

    override func viewDidLoad()
    {
        super.viewDidLoad()
        initDiagram(diagram: diagramView.diagram)
    }
    
    func initDiagram(diagram: Diagram)
    {
        // create child nodes for containers
        for i in 0..<5
        {
            diagram.factory.createShapeNode(
                x: 0, y: 0, width: 10, height: 10)
        }
        for i in 1..<5
        {
            diagram.factory.createDiagramLink(
                origin: diagram.nodes[i / 2], destination: diagram.nodes[i])
        }
        
        for i in 5..<10
        {
            diagram.factory.createShapeNode(
                x: 0, y: 0, width: 10, height: 10)
        }
        for i in 1..<5
        {
            diagram.factory.createDiagramLink(
                origin: diagram.nodes[5 + i / 2], destination: diagram.nodes[5 + i])
        }
        
        // create containers
        var ctr = Array<ContainerNode>()
        for c in 0..<2
        {
            var container = diagram.factory.createContainerNode(
                x: 0, y: 0, width: 10, height: 10);
            for i in (c*5)..<(c*5+5)
            {
                container.add(diagram.nodes[i])
            }
            
            container.arrange(TreeLayout())
            container.foldable = true
            container.zIndex = 0
            container.text = "container " + String(c + 1)
            container.brush = SolidColorBrush(color: Colors.AliceBlue)
            
            ctr.append(container)
        }
        
        ctr[0].move(x: 20, y: 20, updateDependencies: true)
        ctr[1].move(x: 90, y: 20, updateDependencies: true)
        diagram.factory.createDiagramLink(origin: ctr[0], destination: ctr[1])

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBOutlet var diagramView: DiagramView!
}
